
import com.urbancode.air.*
import com.urbancode.air.plugin.automation.*

final def apTool = new AirPluginTool(this.args[0], this.args[1])
final def workDir = new File('.').canonicalFile
def stepProps = apTool.getStepProperties()

def dir = new File(workDir, stepProps['workDirOffset'] ?: '.').canonicalFile

def serverUrl = stepProps['serverUrl']
def username = stepProps['username']
def password = stepProps['password'] ? stepProps['password'] : stepProps['passwordscript']

def domain = stepProps['qcdomain']
def project = stepProps['qcproject']
def issueIds = stepProps['issueIds']
def outFile = stepProps['outFile']

QCPublishBugReport report = new QCPublishBugReport()
report.serverUrl = serverUrl
report.username = username
report.password = password
report.domain = domain
report.project = project
report.issueIds = issueIds
report.outputFileName = outFile

report.workDir = dir

report.execute()

/*import org.codehaus.groovy.scriptom.ActiveXObject
import org.codehaus.groovy.scriptom.Scriptom

import com.jacob.com.Variant

final def varientNull = Variant.VariantNull

final def isWindows = (System.getProperty('os.name') =~ /(?i)windows/).find()

final def workDir = new File('.').canonicalFile

def exitcode = 0

try {
    Scriptom.inApartment {
        def testDirector = null

        final def stepProps = new Properties();
        final def inputPropsFile = new File(args[0]);
        final def inputPropsStream = null;
        try {
            inputPropsStream = new FileInputStream(inputPropsFile);
            stepProps.load(inputPropsStream);
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }

        def serverUrl = stepProps['serverUrl']
        def username = stepProps['username']
        def password = stepProps['password'] ? stepProps['password'] : stepProps['passwordscript']
        def domain = stepProps['qcdomain']
        def project = stepProps['qcproject']
        def failmode = stepProps['failmode']
        def issueIds = stepProps['issueIds']?.split(',') as List;
        def outFile = stepProps['outFile'];

        try {
            println 'Creating connection to Quality Center server';
            testDirector = new ActiveXObject("TDApiOle80.TDConnection")
            testDirector.InitConnectionEx(serverUrl)
            testDirector.Login(username, password)
            testDirector.Connect(domain, project)
            println 'Connection established'

            def bugFactory = testDirector.BugFactory

            def bugFilter = bugFactory.Filter
            def bugpattern = stepProps['bugpattern']

            if (!issueIds) {
                println 'No defects found in source changes!'
            }
            else {
                boolean foundbug = false;
                def issuesXml = new java.io.StringWriter()
                new groovy.xml.MarkupBuilder(issuesXml).issues() {
                    for (def artifactId in issueIds) {
                        try {
                            def artifactData = bugFactory.item(artifactId)

                            // this throws an exception and a issue entry is not created if the defect was not found
                            def summary = artifactData['Summary']
                            def bgDesc = artifactData.Field('BG_DESCRIPTION')

                            if (bgDesc) {
                                // HTML replacement on the description
                                bgDesc = bgDesc.replace("<html>", "");
                                bgDesc = bgDesc.replace("</html>", "");
                                bgDesc = bgDesc.replace("<body>", "");
                                bgDesc = bgDesc.replace("</body>", "");
                                bgDesc = bgDesc.replace("<b>", "");
                                bgDesc = bgDesc.replace("</b>", "");
                                bgDesc = bgDesc.replace("<i>", "");
                                bgDesc = bgDesc.replace("</i>", "");
                                bgDesc = bgDesc.replace("<u>", "");
                                bgDesc = bgDesc.replace("</u>", "");
                                bgDesc = bgDesc.replace("<br>", "\n");
                                bgDesc = bgDesc.replace("&lt;", "<");
                                bgDesc = bgDesc.replace("&gt;", ">");
                                bgDesc = bgDesc.replace("&amp;", "&");
                                bgDesc = bgDesc.replace("&quot;", "\"");
                            }

                            issue(id: artifactId, "issue-tracker": "HP Quality Center") {
                                name(summary)
                                type("Defect")
                                status(artifactData['Status'])
                                description(bgDesc)
                            }
                        }
                        catch (Exception e) {
                            e.printStackTrace()
                            println "Defect $artifactId not found."
                            if (failmode == "slow") {
                                println "Step fail mode is 'Fail'. Step will fail after processing all defects."
                                exitcode = 1
                            }
                            else if (failmode == "warn") {
                                println "Step fail mode is 'Warn'. Step will complete successfully after processing all defects."
                            }
                            else { // fail-fast is default
                                println "Step fail mode is 'Fail-fast'. Failing step now."
                                throw new Exception("Not all referenced defects were found to report on and step fail mode is 'Fail-fast'.")
                            }
                        }
                    }
                }

                File outputFile = new File(outFile);
                outputFile << issuesXml 

                println("Quality Center results outputed successfully")
            }
        }
        finally {
            if (testDirector) {
                try {
                    if (testDirector.Connected()) {
                        testDirector.Disconnect()
                    }
                    if (testDirector.LoggedIn()) {
                        testDirector.Logout()
                    }
                    testDirector.ReleaseConnection()
                    testDirector.safeRelease()
                }
                catch (Exception e) {}
            }
        }
    }
}
catch (Exception e) {
    println e.getMessage()
    exitcode = 1
}

com.jacob.com.ComThread.Release();

if (exitcode) {
    System.exit(exitcode)
}*/
