import com.urbancode.air.*
import com.urbancode.air.plugin.automation.*

final def apTool = new AirPluginTool(this.args[0], this.args[1])
final def workDir = new File('.').canonicalFile
def stepProps = apTool.getStepProperties()

def dir = new File(workDir, stepProps['workDirOffset'] ?: '.').canonicalFile

def serverUrl = stepProps['serverUrl']
def username = stepProps['username']
def password = stepProps['password'] ? stepProps['password'] : stepProps['passwordscript']

def domain = stepProps['qcdomain']
def project = stepProps['qcproject']
def folder = stepProps['folder']
def testSetName = stepProps['testSetName']
def skipOutput = Boolean.valueOf(stepProps['skipOutput'])
def remoteHost = stepProps['remotehost']

QCRunTest runTest = new QCRunTest()
runTest.serverUrl = serverUrl
runTest.username = username
runTest.password = password
runTest.domain = domain
runTest.project = project

runTest.folder = folder
runTest.testSetName = testSetName
runTest.skipOutput = skipOutput
runTest.remoteHost = remoteHost

runTest.workDir = dir

runTest.execute()

/*import org.codehaus.groovy.scriptom.ActiveXObject
import org.codehaus.groovy.scriptom.Scriptom
import java.util.Date

import com.jacob.com.Variant

import java.text.SimpleDateFormat
import java.util.Date
import java.util.TimeZone

println("java.library.path=" + System.getProperty("java.library.path"))

Scriptom.inApartment{
    def testDirector = null
    try {
        final def stepProps = new Properties();
        final def inputPropsFile = new File(args[0]);
        final def inputPropsStream = null;
        try {
            inputPropsStream = new FileInputStream(inputPropsFile);
            stepProps.load(inputPropsStream);
        }
        catch (IOException e) {
            throw new RuntimeException(e);
        }

		def serverUrl = stepProps['serverUrl']
		def username = stepProps['username']
		def password = stepProps['password'] ? stepProps['password'] : stepProps['passwordscript']
		
		def domain = stepProps['qcdomain']
		def project = stepProps['qcproject']
		def folder = stepProps['folder']
		def testSetName = stepProps['testSetName']
		def remoteHost = stepProps['remotehost']
		
		println 'Creating connection to Quality Center server'
        testDirector = new ActiveXObject("TDApiOle80.TDConnection")
        testDirector.InitConnectionEx(serverUrl)
        testDirector.Login(username, password)
        testDirector.Connect(domain, project)
	    println 'Connection established'
		
		def testSetTreeManager = null
		try {
		    testSetTreeManager = testDirector.TestSetTreeManager
		}
		catch(Exception e) {
		    println "Exception on tree manager: " + e.toString()
		}

        def testSetFolder = null

		println "Looking for folder $folder"
		try {
		    testSetFolder = testSetTreeManager.NodeByPath(folder)
		}
		catch(Exception e) {
			println "Couldn't find the folder. Double check it exists and is spelled correctly."
			throw e
		}
		println "Found the folder in QC"
		
        def testSetList 
		try {
		    testSetList = testSetFolder.FindTestSets(testSetName)
		}
		catch(Exception e) {
			println "Couldn't find test set named $testSetName in $folder. Double check it is spelled correctly and in the correct folder."
			throw e
		}
        println "Found ${testSetList.Count} Test Sets"
		
        if (testSetList.Count == 0) {
            throw new Exception("Test Set named ${testSetName} not found.")
        }
        if (testSetList.Count > 1) {
            throw new Exception("Multiple Test Sets named ${testSetName} were found.")
        }
        
        def testSet = testSetList.Item(1)
        println "Running TestSet with ID ${testSet.ID}"
        
        def scheduler = testSet.StartExecution("")
        
        if (remoteHost == null || remoteHost.length() == 0) {
            scheduler.RunAllLocally = true
        }
        else {
            scheduler.TdHostName = remoteHost
        }

        def startDate = new Date()
        scheduler.Run()

        def executionStatus = scheduler.ExecutionStatus

        def finished = false
        while (!finished) {
            executionStatus.RefreshExecStatusInfo("all", true)
            finished = executionStatus.Finished
            def eventList = executionStatus.EventsList()
            if (eventList.Count > 0) {
	            for (i in 0..<eventList.Count) {
	                def event = eventList.Item(i + 1)
	                def eventType = null
	                if (event.EventType == 1) {
	                    eventType = "fail"
	                }
	                else if (event.EventType == 2) {
	                    eventType = "finished"
	                }
	                else if (event.EventType == 3) {
	                    eventType = "env fail"
	                }
	                else if (event.EventType == 4) {
	                    eventType = "timeout"
	                }
	                else if (event.EventType == 5) {
	                    eventType = "manual"
	                }
	                print "\tEvent: ${event.EventDate}"
	                print " ${event.EventTime}"
	                println " EventType: ${eventType}"
	            }
            }
            Thread.sleep(5000L)
        }
        def endDate = new Date()

        def hoursFloat =  ((endDate.time - startDate.time) / (1000 * 60 * 60))
        int hours = hoursFloat
        def minutesFloat = (hoursFloat - hours) * 60
        int minutes = minutesFloat
        def secondsFloat = (minutesFloat - minutes) * 60
        int seconds = secondsFloat

        println "Scheduler finished at ${endDate.toString()}"
        println "Test Set took ${hours} hours, ${minutes} minutes, ${seconds} seconds to run"
        println ""
        println "Test execution statuses:"
        for (i in 0..<executionStatus.Count) {
            def testExecutionStatus = executionStatus.Item(i + 1)
            print "\tTest ${testExecutionStatus.TestId}"
            print ", Test Set Instance ${testExecutionStatus.TestInstance}"
            print ", Order ${testExecutionStatus.TsTestId}"
            print ": ${testExecutionStatus.Message}"
            println ", Status ${testExecutionStatus.Status}"
        }
    }
    catch (Exception e) {
		println "Exception: " + e.toString()
		throw e
	}
    finally {
    	if (testDirector) {
	        try {
		        if (testDirector.Connected()) {
		            testDirector.Disconnect()
		        }
		        if (testDirector.LoggedIn()) {
		            testDirector.Logout()
		        }
	            testDirector.ReleaseConnection()
	            testDirector.safeRelease()
	        }
	        catch (Exception e) {}
        }
    }
}
com.jacob.com.ComThread.Release();
*/